function X=HermiteSplineGraf(val);
handles = guidata(gcf);
ctrl = handles.ctrl;

[n, d] = size(ctrl);

dCtrl = diff(ctrl);
ddCtrl = diff(dCtrl);

switch val
case 1
    if (handles.ncurves == 1),
        hold off;
    end
    X = handles.X;
    cm = uicontextmenu('Tag', 'Change_color');
        % menu di cambio colore
        sm = uimenu(cm, 'Tag', 'Select_color', 'Label', 'Select color');
        uimenu(sm, 'Label', 'Black', 'Callback', 'change_color(''k'')');
        uimenu(sm, 'Label', 'Red', 'Callback', 'change_color(''r'')');
        uimenu(sm, 'Label', 'Green', 'Callback', 'change_color(''g'')');
        uimenu(sm, 'Label', 'Blue', 'Callback', 'change_color(''b'')');
        uimenu(sm, 'Label', 'Yellow', 'Callback', 'change_color(''y'')');
        uimenu(sm, 'Label', 'Cyan', 'Callback', 'change_color(''c'')');        
        uimenu(sm, 'Label', 'Magenta', 'Callback', 'change_color(''m'')');                
        % cambio tratteggio
        tr = uimenu(cm, 'Tag', 'Select_trat', 'Label', 'Select Line');
        uimenu(tr, 'Label', '1', 'Callback', 'change_trat(1)');
        uimenu(tr, 'Label', '2', 'Callback', 'change_trat(2)');
        uimenu(tr, 'Label', '3', 'Callback', 'change_trat(3)');
        uimenu(tr, 'Label', '4', 'Callback', 'change_trat(4)');
        uimenu(tr, 'Label', '5', 'Callback', 'change_trat(5)');            
    
    if (d == 2),
        hp = plot(X(:,1), X(:,2), handles.property.color, ctrl(:, 1), ctrl(:, 2), 'ro', ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:');
        hold on;
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');    
        for i=1:n,
            tt = text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
            set(tt, 'Tag', strcat('c_', handles.name));            
        end
    else
        hp = plot3(X(:,1), X(:,2), X(:,3), handles.property.color, ctrl(:, 1), ctrl(:, 2), ctrl(:, 3), 'ro', ctrl(:,1), ctrl(:,2), ctrl(:,3), 'r*', ctrl(:,1),ctrl(:,2), ctrl(:,3), 'r:');
        hold on;        
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');
        zl = get(gca, 'ZLim');    
        for i=1:n,
            tt = text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50, ctrl(i,3)+ (zl(2) - zl(1))/50, num2str(i), 'FontWeight', 'Bold');
            set(tt, 'Tag', strcat('c_', handles.name));            
        end                
    end
    set(hp,{'Linewidth'},{handles.property.trat; 1; 1; 1});
    set(hp, 'Tag', strcat('c_', handles.name));
    set(hp, 'UIContextMenu', cm);
    title('Interpolante di Hermite', 'FontWeight', 'Bold');
case 2
    hf = findobj('Tag', 'first_der');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'first_der', 'Name', 'First Derivate');
    else
        figure(hf);
    end
    clf;
    
    dX = handles.dX;
    P = handles.ctrl';
    ind = handles.param;    
    t=param(P,ind);
    w=bessel(t,P);

    if (d == 2),    
        hp = plot(dX(:,1), dX(:,2), w(1,:), w(2,:), 'r:', w(1,:), w(2,:), 'r*');
        set(hp,{'Linewidth'},{handles.property.trat; 1; 1});
    else
        hp = plot3(dX(:,1), dX(:,2), dX(:,3), w(1,:), w(2,:), w(3,:), 'r:', w(1,:), w(2,:), w(3,:), 'r*');
        set(hp,{'Linewidth'},{handles.property.trat;1;1});
    end 
    xl = get(gca, 'XLim');
    yl = get(gca, 'YLim');    
    for i=1:length(w),
        text(w(1,i) + (xl(2) - xl(1))/50, w(2,i)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
    end        
    title('Derivata Prima', 'FontWeight', 'Bold');
    grid on;
    figure(findobj('Tag', 'main_figure'));
case 3    
    hf = findobj('Tag', 'second_der');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'second_der', 'Name', 'Second Derivate');
    else
        figure(hf);
    end
    clf;

    ddX = handles.ddX;
    if (d == 2),
        hp = plot(ddX(:,1), ddX(:,2));
        set(hp,{'Linewidth'},{handles.property.trat});
    else
        hp = plot3(ddX(:,1), ddX(:,2), ddX(:,3));
        set(hp,{'Linewidth'},{handles.property.trat});
    end
   
    title('Derivata Seconda', 'FontWeight', 'Bold');
    grid on;
    figure(findobj('Tag', 'main_figure'));
case 4
    t=param(handles.ctrl', handles.param);
    tab = linspace(t(1), t(length(t)), length(handles.K));    
    curvatureplot(handles.K, tab);
case 5
    hf = findobj('Tag', 'curvature_cur');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'curvature_cur', 'Name', 'Curvature and Curve');
    else
        figure(hf);
    end
    clf;
    K = handles.K;
    X = handles.X;

    P = handles.ctrl';
    ind = handles.param;
    t=param(P,ind);
    tab = linspace(t(1), t(length(t)), length(K));
    hold on;
    if (d == 2),
        for i=1:length(tab),
            plot([X(i,1), X(i,1)+K(i)], [X(i,2), X(i,2)+K(i)], 'b');
        end
        plot(X(:,1), X(:,2), 'r');
    else
        for i=1:length(tab),
            plot3([X(i,1), X(i,1)+K(i)], [X(i,2), X(i,2)+K(i)], [X(i,3), X(i,3)+K(i)], 'b');
        end
        plot3(X(:,1), X(:,2), X(:,3), 'r');
    end
    
    title('Curva di Bezier e curvatura', 'FontWeight', 'Bold');
    hold off;
    grid on;
    figure(findobj('Tag', 'main_figure'));  
case 6
    if (d == 3),
        t=param(handles.ctrl', handles.param);
        tab = linspace(t(1), t(length(t)), length(handles.T));  
        torsionplot(handles.T, tab);    
    end    
end
grid on;
return