% function C=InterpolaNewton(P,ttab,ind)
% 
% P -> punti dati
% ttab -> Punti di tabulazione. 
% Attenzione ttab deve essere compreso in [0; 1]
% ind -> Parametrizzazione scelta
%       ind=0 uniforme
%       ind=1 corda
%       ind=2 centripeta
% OUTPUT 
% C : d x ntab
function [X, dX, ddX, dddX]=InterpolaNewton(P, ttab, ind)
[d,n]=size(P);
t=param(P,ind);
A=DiffDiv(t,P);
ntab=length(ttab);
% Algoritmo di Horner per calcolare i valori del polinomio
X(:,1:ntab)=A(:,n)*ones(1,ntab);
for j=1:d
    for i=n-1:-1:1 
        X(j,:)= X(j,:).*(ttab-t(i))+A(j,i);
    end
end
dX = X;
ddX = X;
dddX = X;