% w = bessel(t,P) restituisce in w i punti che la
% derivata prima della curva deve interpolare con
% parametrizzazione t e i punti da interpolare P
% con il metodo di Bessel
% 
% Input
%   t   vettore di parametrizzazione
%   P   punti che la curva deve interpolare
% Output
%   w   punti che la derivata prima deve interpolare

function w=bessel(t,P)
[d,n]=size(P);
h=t(2:n)-t(1:n-1);
diff=P(:,2:n)-P(:,1:n-1);
for i=2:n-1
    w(:,i)=(h(i)/h(i-1)*diff(:,i-1)+h(i-1)/h(i)*diff(:,i))/(h(i-1)+h(i));
end
% tangenti nei punti estremi
w(:,1)=2*diff(:,1)/h(1)-w(:,2);
w(:,n)=2*diff(:,n-1)/h(n-1)-w(:,n-1);
return    