% function [tnew, Qnew]=bezierform(k,a,b,tau,M,Q,ind) 
% scrive la spline in forma di bezier
%
% INPUT
% - k     : ordine della b spline
% - a e b : nodi estremi 
% - tau   : vettore dei nodi interni
% - M     : vettore delle molteplicita'
% - Q     : punti di controllo
% - ind   : parametrizzazione (0 uniforme, 1 cord-length, 2 - centripeta)
%
% OUTPUT 
% tnew - nuovo vettore dei nodi
% Qnew - nuovi punti di controllo

function [tnew, Qnew]=bezierform(k,a,b,tau,M,Q,ind)
L=length(tau)+1;
t=knotvett(k,a,b,tau,M,ind);
% Si fanno ripetute knot insertion in modo che ogni nodo abbia la molteplicita
% massima

tnew=t;
Qnew=Q;
for i=1:L-1
    num=k-1-M(i); % numero di inserimenti che devo fare per arrivare alla moltepl. k-1
    for j=1:num
        [tnew,Qnew]=knotinsert(tnew,Qnew,tau(i));
    end
end
