% function [X] = beziergspline(ind,m)
% Costruisce una Bezier Spline di continuita' 
% G^2 interattivamente
%
% ind - parametrizzazione per i punti da interpolare
% m   - numero di punti di controllo per ogni tratto 
%       (pari al grado piu uno)
function [X] = beziergspline(ind,m)
colormap('jet');
col = colormap;
figure(1);
clf;
hold on;
title('Inserisci i punti da interpolare');
P = ginput';
[d, n] = size(P);
u = param(P,ind);
h = diff(u);
% la prima curva di Bezier ha altri m-2 punti di controllo

title('Bezier Spline');
plot(P(1,:),P(2,:),'ro');
plot(P(1,2), P(2,2),'ko');
str = strcat('Inserisci ',num2str(m-2), ' punti di controllo della prima curva di Bezier');
title(str);
ctrl=ginput(m-2);
title('Bezier Spline');
ctrl=ctrl';
ctrl = [P(:,1) ctrl P(:,2)];
X= casteljau(ctrl,linspace(0,1,100));

hp = plot(X(1,:),X(2,:), ctrl(1,:),ctrl(2,:), ':', ctrl(1,:),ctrl(2,:), '*');
set(hp, {'Color'}, {col(1,:);col(1,:);col(1,:)});
set(hp, {'Linewidth'}, {2;2;1});
xl = get(gca, 'XLim');
yl = get(gca, 'YLim');
for j=1:length(ctrl),
    tt = text(ctrl(1,j) + (xl(2) - xl(1))/50, ctrl(2,j)+ (yl(2) - yl(1))/50,num2str(j), 'FontWeight', 'Bold', 'Color', col(1,:));
end        

for i = 1:n-2
    newctrl(:,1) = ctrl(:,m);
    omega1 = inputdlg('Inserimento omega1', 'Inserisci omega 1');
    omega1 = str2double(omega1);
    if isnan(omega1),
        warndlg('deve essere un valore numerico');
        omega1=1; 
    else
       if omega1<=0
           warndlg('Deve essere maggiore di 0');
           omega1=1;
       end
   end
    
   omega2 = inputdlg('Inserimento omega2', 'Inserisci omega 2');
    omega2 = str2double(omega2);
    if isnan(omega2),
        warndlg('deve essere un valore numerico');
        omega2=1; 
   end
    
    newctrl(:,2) = ctrl(:,m) + omega1*h(i+1)/h(i)*(ctrl(:,m) - ctrl(:,m-1));
    c = newctrl(:,2)-newctrl(:,1);
    num = (m-1)/(h(i)*h(i))*(ctrl(:,m)-2*ctrl(:,m-1)+ctrl(:,m-2)) + (omega1*omega1*(m-1)/(h(i+1)*h(i+1)) - omega2/h(i+1))*c;
    den = omega1*omega1*(m-1)/(h(i+1)*h(i+1));
    
    newctrl(:,3) = newctrl(:,2) + num./den;
    

    hd = plot(newctrl(1,:),newctrl(2,:),'r:',P(1,i+2),P(2,i+2),'mo',P(1,i+2),P(2,i+2),'m*');
    pause;
    if (m>=5)
        str = strcat('Inserisci ',num2str(m-4), ' punti di controllo della',num2str(i+1), 'a curva di Bezier');
        title(str);        
        newctrl(:,4:m-1)=ginput(m-4)';
        title('Bezier Spline');
    end
    newctrl(:,m)=P(:,i+2);
    ctrl = newctrl;
    X1= casteljau(ctrl,linspace(0,1,100));

    hp = plot(X1(1,:),X1(2,:),ctrl(1,:),ctrl(2,:),':', ctrl(1,:),ctrl(2,:),'*');
    cn = floor(length(col)/i);
    set(hp, {'Color'}, {col(cn,:); col(cn,:); col(cn,:)});
    set(hp, {'Linewidth'}, {2;2;1});
    xl = get(gca, 'XLim');
    yl = get(gca, 'YLim');
    for j=1:length(ctrl),
        tt = text(ctrl(1,j) + (xl(2) - xl(1))/50, ctrl(2,j)+ (yl(2) - yl(1))/50,num2str(j), 'FontWeight', 'Bold', 'Color', col(cn,:));
    end        
    
    X= [ X X1 ];
    delete(hd);
end

    
    
    
    
    


