function bsplineplot(val);
handles = guidata(gcf);
ctrl = handles.ctrl;

[n, d] = size(ctrl);

Q = handles.ctrl';
t = handles.pesi;
[d,n]=size(Q);
it=length(t);
k= it-n;
dCtrl(1,1:n-1) = diff(Q(1,:)) ./ (t(k+1:n+k-1) - t(2:n));
dCtrl(2,1:n-1) = diff(Q(2,:)) ./ (t(k+1:n+k-1) - t(2:n));
if (d == 3),
    dCtrl(3,1:n-1) = diff(Q(3,:)) ./ (t(k+1:n+k-1) - t(2:n));
end

ddCtrl(1,1:n-2) = diff(dCtrl(1,:)) ./ (t(k+1:n+k-2) - t(3:n));
ddCtrl(2,1:n-2) = diff(dCtrl(2,:)) ./ (t(k+1:n+k-2) - t(3:n));
if (d == 3),
    ddCtrl(3,1:n-2) = diff(dCtrl(3,:)) ./ (t(k+1:n+k-2) - t(3:n));
end

dCtrl = (k-1)*dCtrl';

ddCtrl = (k-1)*(k-2)*ddCtrl';

switch val
case 1
    if (handles.ncurves == 1),
        hold off;
    end    
    X = handles.X;
    if (d == 2)
        hp = plot(X(:,1), X(:,2), handles.property.color, ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:');
        hold on;
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');    
        for i=1:n,
            tt = text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
            set(tt, 'Tag', strcat('c_', handles.name));            
        end
    else
        hp = plot3(X(:,1), X(:,2), X(:,3), handles.property.color, ctrl(:,1), ctrl(:,2), ctrl(:,3), 'r*' , ctrl(:,1),ctrl(:,2), ctrl(:,3), 'r:');
        hold on;        
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');
        zl = get(gca, 'ZLim');    
        for i=1:n,
            tt = text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50, ctrl(i,3)+ (zl(2) - zl(1))/50, num2str(i), 'FontWeight', 'Bold');
            set(tt, 'Tag', strcat('c_', handles.name));            
        end        
    end
    % costruzione context menu della curva
    cm = uicontextmenu('Tag', 'Change_color');
         % cambio colore
         sm = uimenu(cm, 'Tag', 'Select_color', 'Label', 'Select color');
         uimenu(sm, 'Label', 'Black', 'Callback', 'change_color(''k'')');
         uimenu(sm, 'Label', 'Red', 'Callback', 'change_color(''r'')');
         uimenu(sm, 'Label', 'Green', 'Callback', 'change_color(''g'')');
         uimenu(sm, 'Label', 'Blue', 'Callback', 'change_color(''b'')');
         uimenu(sm, 'Label', 'Yellow', 'Callback', 'change_color(''y'')');
         uimenu(sm, 'Label', 'Cyan', 'Callback', 'change_color(''c'')');        
         uimenu(sm, 'Label', 'Magenta', 'Callback', 'change_color(''m'')');                
         % cambio tratteggio
         tr = uimenu(cm, 'Tag', 'Select_trat', 'Label', 'Select Line');
         uimenu(tr, 'Label', '1', 'Callback', 'change_trat(1)');
         uimenu(tr, 'Label', '2', 'Callback', 'change_trat(2)');
         uimenu(tr, 'Label', '3', 'Callback', 'change_trat(3)');
         uimenu(tr, 'Label', '4', 'Callback', 'change_trat(4)');
         uimenu(tr, 'Label', '5', 'Callback', 'change_trat(5)');            
            
        set(hp, 'UIContextMenu', cm);
        set(hp, 'Tag', strcat('c_', handles.name));
    title('B-Spline', 'FontWeight', 'Bold');
    set(hp,{'Linewidth'},{handles.property.trat;1;1});
case 2
    hf = findobj('Tag', 'first_der');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'first_der', 'Name', 'First Derivate');
    else
        figure(hf);
    end
    clf;
    
    dX = handles.dX;
    
    if (d == 2),
        hp = plot(dX(:,1), dX(:,2), dCtrl(:,1), dCtrl(:,2), 'r*', dCtrl(:,1), dCtrl(:,2), 'r:');
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');    
        for i=1:length(dCtrl),
            text(dCtrl(i,1) + (xl(2) - xl(1))/50, dCtrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
        end        
    else
        hp = plot3(dX(:,1), dX(:,2), dX(:,3), dCtrl(:,1), dCtrl(:,2), dCtrl(:,3), 'r*', dCtrl(:,1), dCtrl(:,2), dCtrl(:,3), 'r:');
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');
        zl = get(gca, 'ZLim');
        len = size(dCtrl);        
        for i=1:len(1),
            text(dCtrl(i,1) + (xl(2) - xl(1))/50, dCtrl(i,2)+ (yl(2) - yl(1))/50, dCtrl(i,3)+ (zl(2) - zl(1))/50, num2str(i), 'FontWeight', 'Bold');
        end        
    end
    title('Derivata Prima', 'FontWeight', 'Bold');
    set(hp,{'Linewidth'},{2;1;1});
    
    grid on;
    figure(findobj('Tag', 'main_figure'));
case 3    
    hf = findobj('Tag', 'second_der');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'second_der', 'Name', 'Second Derivate');
    else
        figure(hf);
    end
    clf;

    ddX = handles.ddX;
    if (d == 2),
        hp = plot(ddX(:,1), ddX(:,2), ddCtrl(:,1), ddCtrl(:,2), 'r*', ddCtrl(:,1), ddCtrl(:,2), 'r:');
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');    
        for i=1:length(ddCtrl),
            text(ddCtrl(i,1) + (xl(2) - xl(1))/50, ddCtrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
        end        
    else
        hp = plot3(ddX(:,1), ddX(:,2), ddX(:,3), ddCtrl(:,1), ddCtrl(:,2), ddCtrl(:,3), 'r*', ddCtrl(:,1), ddCtrl(:,2), ddCtrl(:,3), 'r:');
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');
        zl = get(gca, 'ZLim'); 
        len = size(ddCtrl);
        for i=1:len(1),
            text(ddCtrl(i,1) + (xl(2) - xl(1))/50, ddCtrl(i,2)+ (yl(2) - yl(1))/50, ddCtrl(i,3) + (zl(2) - zl(1))/50, num2str(i), 'FontWeight', 'Bold');
        end        
    end
    title('Derivata Seconda', 'FontWeight', 'Bold');
    set(hp,{'Linewidth'},{2;1;1});
    
    grid on;
    figure(findobj('Tag', 'main_figure'));

    grid on;
    figure(findobj('Tag', 'main_figure'));
case 4
    curvatureplot(handles.K, handles.ttab);
case 5
    hf = findobj('Tag', 'curvature_cur');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'curvature_cur', 'Name', 'Curva con vettore tangente');
    else
        figure(hf);
    end
    clf;

    K = handles.K;
    X = handles.X;
    if (d == 2),
        hp = plot(X(:,1), X(:,2), 'r', ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:');
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');    
        for i=1:n,
            text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
        end        
    else
        hp = plot3(X(:,1), X(:,2), X(:,3), 'r', ctrl(:,1), ctrl(:,2), ctrl(:,3), 'r*', ctrl(:,1),ctrl(:,2), ctrl(:,3),'r:');
        xl = get(gca, 'XLim');
        yl = get(gca, 'YLim');
        zl = get(gca, 'YLim');    
        for i=1:n,
            text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50, ctrl(i,3)+ (zl(2) - zl(1))/50, num2str(i), 'FontWeight', 'Bold');
        end        
    end
    hold on;
    
    for i=1:d,
         diff(i) = (max(ctrl(:,i)) - min(ctrl(:,i)))*.7;
    end
    dX = handles.dX;
    for i=1:length(dX),
        dXn(i,:) = dX(i,:) ./ norm(dX(i,:),2)*(norm(diff,2)*.2);
    end
    ntab = floor(length(handles.ttab) / 20);    
    if (d == 2),
        for i=1:ntab:length(handles.ttab), 
            plot([X(i,1),  X(i,1) + dXn(i,1)], [X(i,2), X(i,2) +  dXn(i,2)], 'b'); 
        end
%         for i=1:length(handles.ttab),
%             plot([X(i,1), X(i,1)+K(i)], [X(i,2), X(i,2)+K(i)], 'b')
%         end
    else
        dXn = handles.dX ./ norm(handles.dX, 2);
        ntab = floor(length(handles.ttab) / 20);
        for i=1:ntab:length(handles.ttab), 
            plot3([X(i,1),  X(i,1) + dXn(i,1)], [X(i,2), X(i,2) +  dXn(i,2)], [X(i,3), X(i,3) +  dXn(i,3)], 'b'); 
        end        
%         for i=1:length(handles.ttab),
%             plot3([X(i,1), X(i,1)+K(i)], [X(i,2), X(i,2)+K(i)], [X(i,3), X(i,3)+K(i)], 'b')
%         end
    end
    title('Curva B-spline con vettore tangente', 'FontWeight', 'Bold');
    set(hp,{'Linewidth'},{2;1;1});
    hold off;

    grid on;
    figure(findobj('Tag', 'main_figure'));
case 6
    if (d == 3)
        torsionplot(handles.T, handles.ttab);
    end
end
grid on;
return