function conicaplot(val);
handles = guidata(gcf);
ctrl = handles.ctrl;

[n, d] = size(ctrl);

dCtrl = diff(ctrl);
ddCtrl = diff(dCtrl);

switch val
case 1
    if (handles.ncurves == 1),
        hold off;
    end    
    X = handles.X;
    
    s = handles.pesi(1);
    M = (ctrl(1,:)+ctrl(3,:))/2;
    P = s * ctrl(2,:) +(1-s)*M;

    hp = plot(X(:,1), X(:,2), ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:', [ctrl(1,1),ctrl(3,1)],[ctrl(1,2), ctrl(3,2)], 'r:',[ctrl(2,1) M(1)],[ctrl(2,2) M(2)],'g:',P(1),P(2),'ro');

    if handles.pesi(1) < .5;
        dim = size(X) / 2;
        hp = plot(X(1:dim,1), X(1:dim,2), handles.property.color, X(dim+1:size(X),1), X(dim+1:size(X),2), handles.property.color, ...
            ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:', [ctrl(2,1) M(1)],[ctrl(2,2) M(2)],'g:',P(1),P(2),'ro');
        set(hp,{'Linewidth'},{handles.property.trat;handles.property.trat;1;1;2;1});
    else
        hp = plot(X(:,1), X(:,2), handles.property.color, ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:', ...
            [ctrl(2,1) M(1)],[ctrl(2,2) M(2)],'g:',P(1),P(2),'ro');        
        set(hp,{'Linewidth'},{handles.property.trat; 1; 1;2;1});
    end
    hold on;
    xl = get(gca, 'XLim');
    yl = get(gca, 'YLim');    
    for i=1:n,
         tt = text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
         set(tt, 'Tag', strcat('c_', handles.name));            
    end
    % costruzione context menu della curva
    cm = uicontextmenu('Tag', 'Change_color');
         % cambio colore
         sm = uimenu(cm, 'Tag', 'Select_color', 'Label', 'Select color');
         uimenu(sm, 'Label', 'Black', 'Callback', 'change_color(''k'')');
         uimenu(sm, 'Label', 'Red', 'Callback', 'change_color(''r'')');
         uimenu(sm, 'Label', 'Green', 'Callback', 'change_color(''g'')');
         uimenu(sm, 'Label', 'Blue', 'Callback', 'change_color(''b'')');
         uimenu(sm, 'Label', 'Yellow', 'Callback', 'change_color(''y'')');
         uimenu(sm, 'Label', 'Cyan', 'Callback', 'change_color(''c'')');        
         uimenu(sm, 'Label', 'Magenta', 'Callback', 'change_color(''m'')');                
         % cambio tratteggio
         tr = uimenu(cm, 'Tag', 'Select_trat', 'Label', 'Select Line');
         uimenu(tr, 'Label', '1', 'Callback', 'change_trat(1)');
         uimenu(tr, 'Label', '2', 'Callback', 'change_trat(2)');
         uimenu(tr, 'Label', '3', 'Callback', 'change_trat(3)');
         uimenu(tr, 'Label', '4', 'Callback', 'change_trat(4)');
         uimenu(tr, 'Label', '5', 'Callback', 'change_trat(5)');            
            
        set(hp, 'UIContextMenu', cm);
        set(hp, 'Tag', strcat('c_', handles.name));
    title('Conica', 'FontWeight', 'Bold');
case 2
    hf = findobj('Tag', 'first_der');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'first_der', 'Name', 'First Derivate');
    else
        figure(hf);
    end
    clf;
    
    dX = handles.dX;
    dCtrl = (n-1)*dCtrl;
    if handles.pesi(1) < .5,
        dim = size(dX);
        dim2 = dim / 2;
        hp = plot(dX(1:dim2,1), dX(1:dim2,2), handles.property.color, dX(dim2+1:dim,1), dX(dim2+1:dim,2), handles.property.color, ...
            dCtrl(:,1), dCtrl(:,2), 'r*', dCtrl(:,1), dCtrl(:,2), 'r:');
        set(hp,{'Linewidth'},{handles.property.trat; handles.property.trat; 1;1});
    else
        hp = plot(dX(:,1), dX(:,2), dCtrl(:,1), dCtrl(:,2), 'r*', dCtrl(:,1), dCtrl(:,2), 'r:');
        set(hp,{'Linewidth'},{handles.property.trat; 1; 1});
    end
        
    xl = get(gca, 'XLim');
    yl = get(gca, 'YLim');    
    for i=1:length(dCtrl),
        text(dCtrl(i,1) + (xl(2) - xl(1))/50, dCtrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
    end        
    title('Derivata Prima', 'FontWeight', 'Bold');
    grid on;
    figure(findobj('Tag', 'main_figure'));
case 3    
    hf = findobj('Tag', 'second_der');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'second_der', 'Name', 'Second Derivate');
    else
        figure(hf);
    end
    clf;

    ddX = handles.ddX;
    ddCtrl = (n-1)*(n-2)*ddCtrl;

    if handles.pesi(1) < .5,
        dim = size(ddX);
        dim2 = dim / 2;
        hp = plot(ddX(1:dim2,1), ddX(1:dim2,2), handles.property.color, ddX(dim2+1:dim,1), ddX(dim2+1:dim,2), handles.property.color, ...
            dCtrl(:,1), dCtrl(:,2), 'r*', dCtrl(:,1), dCtrl(:,2), 'r:');
        set(hp,{'Linewidth'},{handles.property.trat; handles.property.trat; 1;1});
    else
        hp = plot(ddX(:,1), ddX(:,2), ddCtrl(:,1), ddCtrl(:,2), 'r*', ddCtrl(:,1), ddCtrl(:,2), 'r:');
        set(hp,{'Linewidth'},{handles.property.trat; 1; 1});
    end
    

    xl = get(gca, 'XLim');
    yl = get(gca, 'YLim');    
    for i=1:length(ddCtrl),
        text(ddCtrl(i,1) + (xl(2) - xl(1))/50, ddCtrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
    end        
    title('Derivata Seconda', 'FontWeight', 'Bold');
    grid on;
    figure(findobj('Tag', 'main_figure'));
case 4
    hf = findobj('Tag', 'curvature');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'curvature', 'Name', 'Curvature');
    else
        figure(hf);
    end
    clf;
    K = handles.K;
    ttab = handles.ttab;
    if (handles.pesi(1) < .5),
        dim = length(K); dim2 = dim / 2;
        hp = plot(ttab, K(1:dim2), ttab, K(dim2+1:dim));
        set(hp,{'Linewidth'},{2;2});
    else
        hp = plot(ttab, K);
        set(hp,{'Linewidth'},{2});
    end
    title('Curvatura', 'FontWeight', 'Bold');
    grid on;
    figure(findobj('Tag', 'main_figure'));    
case 5
    hf = findobj('Tag', 'curvature_cur');
    if isempty(hf),
        hf = figure;
        set(hf, 'Tag', 'curvature_cur', 'Name', 'Curva con vettore tangente');
    else
        figure(hf);
    end
    clf;
    K = handles.K;
    X = handles.X;

    if handles.pesi(1) < .5
        dim = size(X) / 2;
        hp = plot(X(1:dim,1), X(1:dim,2), handles.property.color, X(dim+1:size(X),1), X(dim+1:size(X),2), handles.property.color, ...
            ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:');
        set(hp,{'Linewidth'},{handles.property.trat;handles.property.trat;1;1});
    else
        hp = plot(X(:,1), X(:,2), handles.property.color, ctrl(:,1), ctrl(:,2), 'r*', ctrl(:,1),ctrl(:,2), 'r:');        
        set(hp,{'Linewidth'},{handles.property.trat; 1; 1});
    end
    
    xl = get(gca, 'XLim');
    yl = get(gca, 'YLim');    
    for i=1:n,
        text(ctrl(i,1) + (xl(2) - xl(1))/50, ctrl(i,2)+ (yl(2) - yl(1))/50,num2str(i), 'FontWeight', 'Bold');
    end        
    hold on;
    for i=1:length(handles.ttab),
        plot([X(i,1), X(i,1)+K(i)], [X(i,2), X(i,2)+K(i)], 'b')
        if handles.pesi(1) < .5
            sw = i + length(handles.ttab);
            plot([X(sw,1), X(sw,1)+K(i)], [X(sw,2), X(sw, 2) + K(sw)], 'g');
        end
        
    end
    title('Curva di Bezier e curvatura', 'FontWeight', 'Bold');
    hold off;
    grid on;
    figure(findobj('Tag', 'main_figure'));    
end
grid on;
return