% K = curvature(dX, ddX) calcola la curvatura della curva X
% 
% Input
%     dX  derivata prima di X
%     ddX derivata seconda di X
% Output
%     K   curvatura di X

function K = curvature(dX, ddX)
[n, d] = size(dX);
if (d == 2),    
    C = dX(:,1).*ddX(:,2) - dX(:,2).*ddX(:,1);
    D = (sqrt(dX(:,1).^2 + dX(:,2).^2)).^3;
    K = C./D;
else
    for t=1:length(dX),
        K(t) = norm(cross(dX(t,:),ddX(t,:)),2) / (norm(dX(t,:),2)^3);
    end
end
return
