function varargout = load_save_sel(new_sel)
handles = guidata(gcf);
if strcmp(new_sel, handles.name),
    return
end
% Eliminazione grafico e dati curva corrente
clearselectsel;
ctrl = handles.ctrl;
if (~isempty(ctrl))
    for i=1:length(ctrl)
        delete(findobj(handles.hdata, 'Tag', strcat('ETX', num2str(i))));
        delete(findobj(handles.hdata, 'Tag', strcat('ETY', num2str(i))));
        delete(findobj(handles.hdata, 'Tag', strcat('ETZ', num2str(i))));        
        delete(findobj(handles.hdata, 'Tag', strcat('Pesi', num2str(i))));        
    end
end

% Salvataggio curva corrente
S = struct('ctrl', handles.ctrl, 'tipo', handles.tipo, ...
     'name', handles.name, 'pesi', handles.pesi, ...
     'X', handles.X, 'dX', handles.dX, 'ddX', handles.ddX, 'K', handles.K, ...
     'T', handles.T, 'ttab', handles.ttab, 'param', handles.param, ...
     'color', handles.property.color, 'trat', handles.property.trat);
h_old = findobj(gcf, 'Tag', strcat('des_', handles.name));
if ~isempty(h_old),
    delete(h_old);
end
[n, d] = size(handles.ctrl);
if (d == 2),
    des = plot(handles.X(:,1), handles.X(:,2), handles.property.color);
else
    des = plot3(handles.X(:,1), handles.X(:,2), handles.X(:,3), handles.property.color);
end
set(des, 'Linewidth', handles.property.trat);
set(des, 'UserData', S, 'Tag', strcat('des_', handles.name));

h_new = findobj('Tag', strcat('des_', new_sel));
S = get(h_new, 'UserData');
handles.ctrl = S.ctrl;
handles.tipo = S.tipo; 
handles.name = S.name;
handles.pesi = S.pesi;
handles.X = S.X; 
handles.dX = S.dX; 
handles.ddX = S.ddX; 
handles.K = S.K;
% handles.T = S.T;
handles.ttab = S.ttab;
handles.param = S.param;
handles.property.color = S.color;
handles.property.trat = S.trat;
delete(h_new);
guidata(gcf, handles);
plotcurve(1, handles.tipo);

visaddpoint(S.ctrl, S.pesi);

