% nu di dimensione n-2
% ind=0 uniforme
% ind=1 corda
% ind=2 centripeta
function [X, dX, ddX]=splinenat(P,ind);
[d,n]=size(P);
dttab=1/((n-1)*1000);
t=param(P,ind);
h=t(2:n)-t(1:n-1);
diff=P(:,2:n)-P(:,1:n-1);

% agli estremi 
A=zeros(n,n);
if (P(:,1)==P(:,n))
    % se la curva e' chiusa 
    A(1,2)=h(n-1);
    A(1,1)=2*(h(1)+h(n-1));
    A(1,n-1)=h(1);
    b(:,1)=3*(h(n-1)/h(1)*diff(:,1)+h(1)/h(n-1)*diff(:,n-1));
    A(n,1)=1;
    A(n,n)=-1;
    b(:,n)=0;
else
    % se la curva e' aperta
    A(1,1)=2*h(1);
    A(1,2)=h(1);
    b(:,1)=3*diff(:,1);
    A(n,n)=2*h(n-1); 
    A(n,n-1)=h(n-1);
    b(:,n)=3*diff(:,n-1);
end

% parte interna
for i=2:n-1
    A(i,i-1)=h(i);
    A(i,i)=2*(h(i-1)+h(i));
    A(i,i+1)=h(i-1);
    b(:,i)=3*(h(i)/h(i-1)*diff(:,i-1)+h(i-1)/h(i)*diff(:,i));
end
b=b';
w=(A\b)';
hold on;
X = [];
for r=1:n-1
    % segmento di cubica che sto considerando
    % in ogni segmento prendo un numero di punti 
    nloc=floor(h(r)/dttab);
    ttabLoc=linspace(0,1,nloc); 
    % restituisce un vettore equispaziato nell'intervallo [0,1]
    % perche' voglio usare Bezier
    Q(:,1)=P(:,r); % primo punto di Bezier
    Q(:,4)=P(:,r+1); % ultimo "   "   "
    Q(:,2)=Q(:,1)+h(r)*w(:,r)/3;
    Q(:,3)=Q(:,4)-h(r)*w(:,r+1)/3;
    [tmp(:,1:nloc,r), dtmp(:,1:nloc,r), ddtmp(:,1:nloc,r)]=casteljau(Q,ttabLoc);
    X = [X tmp(:,1:nloc,r)];
    dX = [dX dtmp(:,1:nloc,r)./h(r)];
    ddX = [ddX ddtmp(:,1:nloc,r)./(h(r)*h(r))];   
end
return