% [cl,cr]=subdivision(b,t) calcola il partizionamento della curva
% di Bezier di punti di controllo b.
%
% Input
%    b    punti di controllo della curva da partizionare
%    t    punto interno a [0, 1] in cui partizionare la curva
% Output
%    cl   punti di controllo della porzione di sinistra
%    cr   punti di controllo della porzione di destra

function [cl,cr]=subdivision(b,t)
[d,n]=size(b);
C(:,:)=b(:,:);
cr(:,1)=b(:,n);
for r=1:n-1
    cl(:,r)=C(:,1);
    for i=1:n-r
        C(:,i)=(1-t)*C(:,i)+t*C(:,i+1);
    end
    cr(:,r+1)=C(:,n-r);
end
cl(:,n)=C(:,1);
return
